// 
// ʓxAPxAt@Cŕϊ
// AiOtA}CN|[Ή
// JX^ʓxH
// }bṽK}
//
#include <math.h>
#include <esplib.h>

char depth_fn[256];
//char pict_fn[]="depth0.jpg";

//ő傸炵
int shift_max=10;

int gamma_table[256];
double gamma=1.0;
double V_gamma=1.0;
double S_gamma=1.0;
double Smod_gamma=1.0;

int S_correction_table[256];
int S_correct=100;
double S_correct_sub=0.3;

#define S_MOD_MAX 10
int S_mod=9;

int depth_Rev=0;

void make_S_correction_table()
{
	for (int i=0; i<256; i++) {
//		S_correction_table[i] = S_correct + ((255-S_correct)*i)/255;
//		S_correction_table[i] = ((255-S_correct)*i)/255;
		S_correction_table[i] = ((255-S_correct)*((int)(pow((double)i / 255.0, 1.0 / S_correct_sub) * 255.0)))/255;
	}

	ESP_Select(4);
	ESP_BoxFill(0,0,256,256,0,0);
	for (int i=0; i<256; i++){
		ESP_Pset(i, 256-S_correction_table[i], 0xffffff);
	}
	ESP_Update(4);

}


void make_gamma_table()
{
     for (int i = 0; i < 256; i++){  
         gamma_table[i] = (int)(pow((double)i / 255.0, 1.0 / gamma) * 255.0);  
     }  
}

void ESP_Ready(void)
{

	ESP_OpenTextWindow(0,216,0,198,106);

	#define BUTTON_MAX 20

	ESP_OpenButtonBox(0,0,2,BUTTON_MAX/2);

	ESP_SetButtonBoxTitle( 0,"--");
	ESP_SetButtonBoxTitle( 1,"++");

	ESP_SetButtonBoxTitle( 2,"V map");
	ESP_SetButtonBoxTitle( 3,"S map");
	ESP_SetButtonBoxTitle( 4,"anaglyph");
	ESP_SetButtonBoxTitle( 5,"");
	ESP_SetButtonBoxTitle( 6,"I-lace1");
	ESP_SetButtonBoxTitle( 7,"I-lace2");

	ESP_SetButtonBoxTitle( 8,"S mod");
	ESP_SetButtonBoxTitle( 9,"S mod+V");

	ESP_SetButtonBoxTitle(10,"Smod -");
	ESP_SetButtonBoxTitle(11,"Smod +");

	ESP_SetButtonBoxTitle(12,"Scorrect -");
	ESP_SetButtonBoxTitle(13,"Scorrect +");

	ESP_SetButtonBoxTitle(14,"ScorreSub-");
	ESP_SetButtonBoxTitle(15,"ScorreSub+");

	ESP_SetButtonBoxTitle(16,"gamma -");
	ESP_SetButtonBoxTitle(17,"gamma +");

	ESP_SetButtonBoxTitle(18,"load");
	ESP_SetButtonBoxTitle(19,"break");



	make_gamma_table();
	make_S_correction_table();

	ESP_Printf("Drop picture\n to ESPLIB window\n and click \"Start\".\n");

}


void draw0()
{

	int shift,p,c;
	int shift0,p0;
	int dd;

	ESP_Select(2);
//	ESP_PutWindow(ESP_VramPtr[0],            0,0,esp_iw[0].wx,esp_iw[0].wy); //܂
	ESP_BoxFill(0,0,esp_iw[0].wx,esp_iw[0].wy,0,0);
	ESP_PutWindow(ESP_VramPtr[0], esp_iw[0].wx,0,esp_iw[0].wx,esp_iw[0].wy);

	//fvXXLA
	for (int y=0; y<esp_iw[1].wy; y++){
		for (int x=0; x<esp_iw[1].wx; x++){
			ESP_Select(1);
			p=C2V(ESP_Point(x, y));
			shift = shift_max*p/256;

			ESP_Select(0);
			c=ESP_Point(x, y);
			ESP_Select(2);
			ESP_Pset(x-shift, y, c);


			//ƂȂ̃hbg
			ESP_Select(1);
			p0=C2V(ESP_Point(x+1, y));
			if (p0<p) {
				shift0 = shift_max*p0/256;
				dd = shift-shift0;

				ESP_Select(0);
				c=ESP_Point(x+1, y);
				ESP_Select(2);
				for (int i=1; i<=dd; i++) {
					ESP_Pset((x-shift)+i, y, c);
				}
			}

		}




	}
	ESP_Update();
}

void draw(int souce, int map, int dest)
//            0          1        2
{

	int shift,p,c;
	int shift0,p0;
	int dd;

	ESP_Select(dest);
//	ESP_PutWindow(ESP_VramPtr[0],            0,0,esp_iw[0].wx,esp_iw[0].wy); //܂
	ESP_BoxFill(0,0,esp_iw[souce].wx,esp_iw[souce].wy,0,0);
	ESP_PutWindow(ESP_VramPtr[souce], esp_iw[souce].wx,0,esp_iw[souce].wx,esp_iw[souce].wy);

	//fvXXLA
	for (int y=0; y<esp_iw[1].wy; y++){
		for (int x=0; x<esp_iw[1].wx; x++){
			ESP_Select(map);
			if (depth_Rev) 
				p=255-C2V(ESP_Point(x, y));
			else
				p=C2V(ESP_Point(x, y));
			shift = shift_max*p/256;

			ESP_Select(souce);
			c=ESP_Point(x, y);
			ESP_Select(dest);
			ESP_Pset(x-shift, y, c);


			//ƂȂ̃hbg
			ESP_Select(map);
			if (depth_Rev) 
				p0=255-C2V(ESP_Point(x+1, y));
			else
				p0=C2V(ESP_Point(x+1, y));
			if (p0<p) {
				shift0 = shift_max*p0/256;
				dd = shift-shift0;

				ESP_Select(souce);
				c=ESP_Point(x+1, y);
				ESP_Select(dest);
				for (int i=1; i<=dd; i++) {
					ESP_Pset((x-shift)+i, y, c);
				}
			}

		}




	}
	ESP_Update(2);
}


#define kongou(c0,c1) RGB2C((C2R(c0)|C2R(c1)), (C2G(c0)|C2G(c1)), (C2B(c0)|C2B(c1)))

void anaglyph()
{
	int col,r,g,b,right,left;

	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(2);
			col = ESP_Point(x+esp_iw[0].wx, y);
			C2RGB(col,&r,&g,&b);
			r = (299*r+587*g+114*b)/1000;
			left = RGB2C(r,0,0);


			col = ESP_Point(x, y);
			C2RGB(col,&r,&g,&b);
			right = RGB2C(0,g,b);

			ESP_Select(3);
			ESP_Pset(x, y, kongou(right,left));

		}
	}
	ESP_SetForeground(3);
	ESP_Update(3);
}


void Ilace1()
{
	int py,col;
	RECT pos;
	GetWindowRect(esp_iw[3].hwnd, &pos);
	//px = pos.left;
	py = pos.top;

	if (py % 2){
		for (int y=0; y<esp_iw[0].wy; y++){
			for (int x=0; x<esp_iw[0].wx; x++){
				ESP_Select(2);
				if (y % 2) col = ESP_Point(x+esp_iw[0].wx, y);
				else col = ESP_Point(x, y);

				ESP_Select(3);
				ESP_Pset(x, y, col);
			}
		}
	}else {
		for (int y=0; y<esp_iw[0].wy; y++){
			for (int x=0; x<esp_iw[0].wx; x++){
				ESP_Select(2);
				if (y % 2) col = ESP_Point(x, y);
				else col = ESP_Point(x+esp_iw[0].wx, y);

				ESP_Select(3);
				ESP_Pset(x, y, col);
			}
		}
	}
	ESP_SetForeground(3);
	ESP_Update(3);
}
void Ilace2()
{
	int py,col;
	RECT pos;
	GetWindowRect(esp_iw[3].hwnd, &pos);
	//px = pos.left;
	py = pos.top;

	if (py % 2){
		for (int y=0; y<esp_iw[0].wy; y++){
			for (int x=0; x<esp_iw[0].wx; x++){
				ESP_Select(2);
				if (y % 2) col = ESP_Point(x, y);
				else col = ESP_Point(x+esp_iw[0].wx, y);

				ESP_Select(3);
				ESP_Pset(x, y, col);
			}
		}
	}else {
		for (int y=0; y<esp_iw[0].wy; y++){
			for (int x=0; x<esp_iw[0].wx; x++){
				ESP_Select(2);
				if (y % 2) col = ESP_Point(x+esp_iw[0].wx, y);
				else col = ESP_Point(x, y);

				ESP_Select(3);
				ESP_Pset(x, y, col);
			}
		}
	}
	ESP_SetForeground(3);
	ESP_Update();
}

int C2Smod(int c)
{
	int h,s,v,x;
	int dd;

	int r=C2R(c);
	int g=C2G(c);
	int b=C2B(c);

	v=max(max(r,g),b);
	x=min(min(r,g),b);

	s=(v+((255-v)*S_mod)/S_MOD_MAX)-x;

	return s;

}
void S_map_mod()
{
	int c;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c=C2Smod(ESP_Point(x, y));
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update_(1);

}
void S_map_modV()
{
	int c;
	int c1,c2;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c1=C2Smod(ESP_Point(x, y));
			c2=C2V(ESP_Point(x, y));
			if (c1>c2) c=c1; else c=c2;
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update_(1);

}

/*

int C2Smod1(int c)
{
	int h,s,v,x;
	int dd;

	int r=C2R(c);
	int g=C2G(c);
	int b=C2B(c);

	v=max(max(r,g),b);
//	if (v==0) dd=0; else dd=255/v;
//	if (v==0) v=1;//
//	dd=v/255;
	x=min(min(r,g),b);

	if (v==0) {v=1;x=1;}//

//	x=x*dd;
//	x=x*256/v;
	x=x*255/v;
	s=255-x;

	return s;

}
int C2Smod2(int c)
{
	int h,s,v,x;
	int dd;

	int r=C2R(c);
	int g=C2G(c);
	int b=C2B(c);

	v=max(max(r,g),b);
//	dd=255/v;
	x=min(min(r,g),b);
//	x=x*dd;
	s=255-x;

	return s;

}
int C2Smod3(int c)
{
	int h,s,v,x;
	int dd;

	int r=C2R(c);
	int g=C2G(c);
	int b=C2B(c);

	v=max(max(r,g),b);
//	if (v==0) dd=0; else dd=255/v;
	if (v==0) v=1;//
//	dd=v/255;
	x=min(min(r,g),b);
//	x=x*dd;
//	x=x*256/v;
	x=((x*255/v)+x)/2;
	s=255-x;

	return s;

}

void S_map_mod1()
{
	int c;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c=C2Smod1(ESP_Point(x, y));
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update();

}
void S_map_mod2()
{
	int c;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c=C2Smod2(ESP_Point(x, y));
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update();

}
void S_map_mod3()
{
	int c;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c=C2Smod3(ESP_Point(x, y));
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update();

}
void S_map_mod1V()
{
	int c;
	int c1,c2;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c1=C2Smod1(ESP_Point(x, y));
			c2=C2V(ESP_Point(x, y));
			if (c1>c2) c=c1; else c=c2;
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update();

}
void S_map_mod2V()
{
	int c;
	int c1,c2;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c1=C2Smod2(ESP_Point(x, y));
			c2=C2V(ESP_Point(x, y));
			if (c1>c2) c=c1; else c=c2;
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update();

}
void S_map_mod3V()
{
	int c;
	int c1,c2;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c1=C2Smod3(ESP_Point(x, y));
			c2=C2V(ESP_Point(x, y));
			if (c1>c2) c=c1; else c=c2;
			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update();

}

*/

void S_map()
{
	int c;
	shift_max=esp_iw[0].wx/32;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			//		c=C2V(ESP_Point(x, y));
			c=C2S(ESP_Point(x, y));
//			c = S_correction_table[c];
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update_(1);

}

void V_map()
{
	int c;
	shift_max=esp_iw[0].wx/64;
	for (int y=0; y<esp_iw[0].wy; y++){
		for (int x=0; x<esp_iw[0].wx; x++){
			ESP_Select(0);
			c=C2V(ESP_Point(x, y));
			//		c=C2S(ESP_Point(x, y));
			c = gamma_table[c];
			ESP_Select(1);
			ESP_Pset(x, y, RGB2C(c,c,c));

		}
	}
	ESP_Update_(1);

}


void ESP_Main(void)

{

	if (ESP_GetDisplayMode(0)) {
		ESP_PlaceImage(0, 216,140);
		ESP_CreateImage(1,"depth",422,0,esp_iw[0].wx,esp_iw[0].wy,100);
		ESP_CreateImage(2,"result", 0,308,esp_iw[0].wx*2,esp_iw[0].wy,100);
		ESP_CreateImage(3,"display", 500,50,esp_iw[0].wx,esp_iw[0].wy,100);
		ESP_CreateImage(4,"S_correct", 300,0,256,256,100);

		//	shift_max=esp_iw[0].wx/32;

		make_S_correction_table();

		S_map_modV();
		ESP_Printf("S_map_modV\n");
//		V_map();
//		ESP_Printf("V_map\n");

//		draw();
		draw(0,1,2);
		ESP_Update_(2);
		anaglyph();

		//	ESP_Printf("Hello, ESPLIB. \n");
		while(1){
			for (int b=0; b<BUTTON_MAX; b++){
				//					ESP_Printf(" %d",b);
				ESP_Printf("");
				if(ESP_GetButtonBox(b)){
					//					ESP_Printf("%d\n",b);

					switch(b){
					case 0:
						shift_max--;
						if (shift_max<0) shift_max=0;
						ESP_Printf("shift:%d\n",shift_max);
						//draw();
						draw(0,1,2);
						ESP_Update_(2);
						break;
					case 1:
						shift_max++;
						ESP_Printf("shift:%d\n",shift_max);
						//draw();
						draw(0,1,2);
						ESP_Update_(2);
						break;
//					case 2:
//						draw();
//						break;
					case 2:
						V_map();
						//draw();
						draw(0,1,2);
						ESP_Update_(2);
						ESP_Printf("V_map\n");
						break;
					case 3:
						S_map();
						//draw();
						draw(0,1,2);
						ESP_Update_(2);
						ESP_Printf("S_map\n");
						break;
					case 4:
						anaglyph();
						break;
					case 5:
						if (depth_Rev) {
							depth_Rev=0;
							ESP_Printf("Normal depth\n");
						} else {
							depth_Rev=1;
							ESP_Printf("Reverse depth\n");
						}
						break;


					case 6:
						Ilace1();
						break;
					case 7:
						Ilace2();
						break;
/*
					case 8:
						S_map_mod1();
						draw();
						ESP_Printf("S_map_mod1\n");
						break;
					case 10:
						S_map_mod2();
						draw();
						ESP_Printf("S_map_mod2\n");
						break;
					case 9:
						S_map_mod1V();
						draw();
						ESP_Printf("S_map_mod1V\n");
						break;
					case 11:
						S_map_mod2V();
						draw();
						ESP_Printf("S_map_mod2V\n");
						break;
					case 12:
						S_map_mod3();
						draw();
						ESP_Printf("S_map_mod3\n");
						break;
					case 13:
						S_map_mod3V();
						draw();
						ESP_Printf("S_map_mod3V\n");
						break;
*/
					case 12://S_correction_table[256];
						S_correct -= 5;
						if (S_correct<0) S_correct=0;
						ESP_Printf("S_correct:%d\n",S_correct);
						make_S_correction_table();
//						draw();
						break;
					case 13:
						S_correct += 5;
						if (S_correct>255) S_correct=255;
						ESP_Printf("S_correct:%d\n",S_correct);
						make_S_correction_table();
//						draw();
						break;
					case 10://S_correction_table[256];
						S_mod -= 1;
						if (S_mod<0) S_mod=0;
						ESP_Printf("S_mod:%d\n",S_mod);
//						make_S_correction_table();
//						draw();
						break;
					case 11:
						S_mod += 1;
						if (S_mod>S_MOD_MAX) S_mod=S_MOD_MAX;
						ESP_Printf("S_mod:%d\n",S_mod);
//						make_S_correction_table();
//						draw();
						break;
					case 8:
						S_map_mod();
						//draw();
						draw(0,1,2);
						ESP_Update_(2);
						ESP_Printf("S_map_mod\n");
						break;
					case 9:
						S_map_modV();
						//draw();
						draw(0,1,2);
						ESP_Update_(2);
						ESP_Printf("S_map_modV\n");
						break;
					case 14:
						S_correct_sub -= 0.1;
						if (S_correct_sub<0) S_correct_sub=0;
						ESP_Printf("S_correct_sub:%f\n",S_correct_sub);
						make_S_correction_table();
//						make_gamma_table();
//						draw();
						break;
					case 15:
						S_correct_sub += 0.1;
						ESP_Printf("S_correct_sub:%f\n",S_correct_sub);
//						make_gamma_table();
						make_S_correction_table();
//						draw();
						break;
					case 16:
						gamma -= 0.1;
						if (gamma<0) gamma=0;
						ESP_Printf("gamma:%f\n",gamma);
						make_gamma_table();
//						draw();
						break;
					case 17:
						gamma += 0.1;
						ESP_Printf("gamma:%f\n",gamma);
						make_gamma_table();
//						draw();
						break;
					case 18:
						ESP_GetOpenFileName(depth_fn, "Select depth_map file", NULL);
						ESP_Select(1);
						if (ESP_ImageLoad(depth_fn, 0, 0, 100)) {
							ESP_Printf("cannnot load\n");
						} else {
							ESP_Printf("load: %s\n",depth_fn);
							ESP_Update();
							shift_max=esp_iw[0].wx/64;
							//draw();
							draw(0,1,2);
						ESP_Update_(2);
						}
						break;
					case 19:
						goto end;
						break;
					}
					//				draw();
				}
			}
			ESP_Sleep(100);
		}
end:
		;

		ESP_DestroyImage(0);
		ESP_DestroyImage(1);
		ESP_DestroyImage(2);
		ESP_DestroyImage(3);
		ESP_DestroyImage(4);

	} else {
		ESP_Pause("摜hbOĉ");
	}
}

void ESP_Finish(void)
{
}